/* 
 * Copyright (c) 2010 ISPRAS
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISPRAS)
 * 25 A.Solzhenitsyn st. Moscow 109004 Russia
 * http://hardware.ispras.ru
 *
 * All rights reserved.
 *
 * This source code is free software; you can redistribute it
 * and/or modify it in source code form under the terms of the GNU
 * General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 * $Id: vpi_systf.h,v 1.3 2010/06/15 14:53:20 chupilko Exp $
 */

#ifndef _VPI_SYSTF_H_INCLUDED_
#define _VPI_SYSTF_H_INCLUDED_

/*
#define VPI_SYSTF_TEMPLATE                                  \
    "    s_vpi_value value;\n\n"                            \
    "    vpiHandle obj = vpi_handle(vpiSysTfCall, NULL);\n" \
    "    vpiHandle itr = vpi_iterate(vpiArgument, obj);\n"  \
    "    vpiHandle arg = vpi_scan(itr);\n\n"                \
    "    value.format = vpiStringVal;\n"                    \
    "    vpi_get_value(arg, &value);\n\n"                   \
    "    // TODO: Add a call of your function here\n\n"     \
    "    vpi_free_object(obj);\n"                           \
    "    vpi_free_object(itr);\n"                           \
    "    vpi_free_object(arg);\n\n"                         \
    "    return 0;\n"                                       \
*/

#define VPI_SYSTF_TEMPLATE                                      \
    "    // TODO: Add parameters of scenario start here\n"      \
    "    int   argc    = 0;\n"                                  \
    "    char *argv[1] = { "" };\n\n"                           \
    "    // TODO: Add name of your scenario here\n"             \
    "    START_SCENARIO(NAME, argc, argv);\n\n" \
    "    return 0;\n"                                           \

#define VPI_SYSTF_TEMPLATE_APPLY                                \
    "    return 0;\n"                                           \

#define VPI_SYSTF_TEMPLATE_CHECK                                \
    "    apply_check();\n"                                      \
    "    return 0;\n"                                           \


#include <stdio.h>

#include "../design.h"
#include "../options.h"

void vt_print_vpi_systf_c(FILE *file, vt_design_t *design, vt_options_t *options);
void vt_print_vpi_systf_h(FILE *file, vt_design_t *design, vt_options_t *options);

#endif // _VPI_MEDIA_H_INCLUDED_
